/* thread_service.c generated by valac 0.56.13, the Vala compiler
 * generated from thread_service.vala, do not modify */

/* services/thread_service.vala
 *
 * Copyright 2022 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef void (*WorkerFunc) (gpointer user_data);
typedef gpointer (*ThreadFunc) (gpointer user_data, GError** error);
typedef struct _Worker Worker;
#define _worker_free0(var) ((var == NULL) ? NULL : (var = (worker_free (var), NULL)))
#define _g_thread_pool_free0(var) ((var == NULL) ? NULL : (var = (g_thread_pool_free (var, FALSE, TRUE), NULL)))
typedef struct _Block27Data Block27Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ThreadServiceRunInThreadData ThreadServiceRunInThreadData;

struct _Worker {
	WorkerFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

struct _Block27Data {
	int _ref_count_;
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gpointer _result_;
	GError* _error_;
	ThreadFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
	gpointer _async_data_;
};

struct _ThreadServiceRunInThreadData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ThreadFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	gpointer result;
	Block27Data* _data27_;
	GThreadPool* thread_pool;
	GThreadPool* _tmp0_;
	GThreadPool* _tmp1_;
	GError* e;
	GError* _tmp2_;
	GError* _tmp3_;
	Worker* _tmp4_;
	GError* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	gconstpointer _tmp8_;
	gpointer _tmp9_;
	GError* _inner_error0_;
};

VALA_EXTERN GOnce thread_service__once;
GOnce thread_service__once = G_ONCE_INIT;

VALA_EXTERN void worker_free (Worker * self);
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worker, worker_free)
static void worker_instance_init (Worker * self);
VALA_EXTERN Worker* worker_new (WorkerFunc func,
                    gpointer func_target,
                    GDestroyNotify func_target_destroy_notify);
VALA_EXTERN void worker_run (Worker* self);
VALA_EXTERN GThreadPool* _thread_service_get_thread_pool (GError** error);
static GThreadPool* __lambda44_ (void);
static void ___lambda45_ (Worker* worker);
static void ____lambda45__gfunc (gpointer data,
                          gpointer self);
static gpointer ___lambda44__gthread_func (gpointer self);
static void thread_service_run_in_thread_data_free (gpointer _data);
VALA_EXTERN void thread_service_run_in_thread (GType g_type,
                                   GBoxedCopyFunc g_dup_func,
                                   GDestroyNotify g_destroy_func,
                                   ThreadFunc func,
                                   gpointer func_target,
                                   GDestroyNotify func_target_destroy_notify,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN gpointer thread_service_run_in_thread_finish (GAsyncResult* _res_,
                                              GError** error);
static gboolean thread_service_run_in_thread_co (ThreadServiceRunInThreadData* _data_);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static void __lambda46_ (Block27Data* _data27_);
static gboolean _thread_service_run_in_thread_co_gsource_func (gpointer self);
static void ___lambda46__worker_func (gpointer self);

Worker*
worker_new (WorkerFunc func,
            gpointer func_target,
            GDestroyNotify func_target_destroy_notify)
{
	Worker* self;
	WorkerFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	self = g_slice_new0 (Worker);
	worker_instance_init (self);
	_tmp0_ = func;
	_tmp0__target = func_target;
	_tmp0__target_destroy_notify = func_target_destroy_notify;
	func = NULL;
	func_target = NULL;
	func_target_destroy_notify = NULL;
	(self->func_target_destroy_notify == NULL) ? NULL : (self->func_target_destroy_notify (self->func_target), NULL);
	self->func = NULL;
	self->func_target = NULL;
	self->func_target_destroy_notify = NULL;
	self->func = _tmp0_;
	self->func_target = _tmp0__target;
	self->func_target_destroy_notify = _tmp0__target_destroy_notify;
	(func_target_destroy_notify == NULL) ? NULL : (func_target_destroy_notify (func_target), NULL);
	func = NULL;
	func_target = NULL;
	func_target_destroy_notify = NULL;
	return self;
}

void
worker_run (Worker* self)
{
	WorkerFunc _tmp0_;
	gpointer _tmp0__target;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->func;
	_tmp0__target = self->func_target;
	_tmp0_ (_tmp0__target);
}

static void
worker_instance_init (Worker * self)
{
}

void
worker_free (Worker * self)
{
	(self->func_target_destroy_notify == NULL) ? NULL : (self->func_target_destroy_notify (self->func_target), NULL);
	self->func = NULL;
	self->func_target = NULL;
	self->func_target_destroy_notify = NULL;
	g_slice_free (Worker, self);
}

static void
___lambda45_ (Worker* worker)
{
	g_return_if_fail (worker != NULL);
	worker_run (worker);
	_worker_free0 (worker);
}

static void
____lambda45__gfunc (gpointer data,
                     gpointer self)
{
	___lambda45_ ((Worker*) data);
}

static GThreadPool*
__lambda44_ (void)
{
	GThreadPool* pool = NULL;
	GError* _inner_error0_ = NULL;
	GThreadPool* result;
	pool = NULL;
	{
		GThreadPool* _tmp0_ = NULL;
		GThreadPool* _tmp1_;
		GThreadPool* _tmp2_;
		_tmp1_ = g_thread_pool_new (____lambda45__gfunc, NULL, 1, FALSE, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_THREAD_ERROR) {
				goto __catch0_g_thread_error;
			}
			_g_thread_pool_free0 (pool);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_thread_pool_free0 (pool);
		pool = _tmp2_;
		_g_thread_pool_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		g_clear_error (&_inner_error0_);
		g_critical ("thread_service.vala:45: Error creating ThreadPool");
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_thread_pool_free0 (pool);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = pool;
	return result;
}

static gpointer
___lambda44__gthread_func (gpointer self)
{
	gpointer result;
	result = __lambda44_ ();
	return result;
}

GThreadPool*
_thread_service_get_thread_pool (GError** error)
{
	gconstpointer _tmp0_;
	GThreadPool* result;
	_tmp0_ = g_once (&thread_service__once, ___lambda44__gthread_func, NULL);
	result = (GThreadPool*) _tmp0_;
	return result;
}

static void
thread_service_run_in_thread_data_free (gpointer _data)
{
	ThreadServiceRunInThreadData* _data_;
	_data_ = _data;
	((_data_->result == NULL) || (_data_->g_destroy_func == NULL)) ? NULL : (_data_->result = (_data_->g_destroy_func (_data_->result), NULL));
	g_slice_free (ThreadServiceRunInThreadData, _data_);
}

void
thread_service_run_in_thread (GType g_type,
                              GBoxedCopyFunc g_dup_func,
                              GDestroyNotify g_destroy_func,
                              ThreadFunc func,
                              gpointer func_target,
                              GDestroyNotify func_target_destroy_notify,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	ThreadServiceRunInThreadData* _data_;
	_data_ = g_slice_new0 (ThreadServiceRunInThreadData);
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, thread_service_run_in_thread_data_free);
	(_data_->func_target_destroy_notify == NULL) ? NULL : (_data_->func_target_destroy_notify (_data_->func_target), NULL);
	_data_->func = NULL;
	_data_->func_target = NULL;
	_data_->func_target_destroy_notify = NULL;
	_data_->func = func;
	_data_->func_target = func_target;
	_data_->func_target_destroy_notify = func_target_destroy_notify;
	_data_->g_type = g_type;
	_data_->g_dup_func = g_dup_func;
	_data_->g_destroy_func = g_destroy_func;
	thread_service_run_in_thread_co (_data_);
}

gpointer
thread_service_run_in_thread_finish (GAsyncResult* _res_,
                                     GError** error)
{
	gpointer result;
	ThreadServiceRunInThreadData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return NULL;
	}
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
	g_atomic_int_inc (&_data27_->_ref_count_);
	return _data27_;
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
		GType g_type;
		GBoxedCopyFunc g_dup_func;
		GDestroyNotify g_destroy_func;
		g_type = _data27_->g_type;
		g_dup_func = _data27_->g_dup_func;
		g_destroy_func = _data27_->g_destroy_func;
		_g_error_free0 (_data27_->_error_);
		((_data27_->_result_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_data27_->_result_ = (g_destroy_func (_data27_->_result_), NULL));
		(_data27_->func_target_destroy_notify == NULL) ? NULL : (_data27_->func_target_destroy_notify (_data27_->func_target), NULL);
		_data27_->func = NULL;
		_data27_->func_target = NULL;
		_data27_->func_target_destroy_notify = NULL;
		g_slice_free (Block27Data, _data27_);
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
	return self ? g_error_copy (self) : NULL;
}

static gboolean
_thread_service_run_in_thread_co_gsource_func (gpointer self)
{
	gboolean result;
	result = thread_service_run_in_thread_co (self);
	return result;
}

static void
__lambda46_ (Block27Data* _data27_)
{
	GType g_type;
	GBoxedCopyFunc g_dup_func;
	GDestroyNotify g_destroy_func;
	GError* _inner_error0_ = NULL;
	g_type = _data27_->g_type;
	g_dup_func = _data27_->g_dup_func;
	g_destroy_func = _data27_->g_destroy_func;
	{
		gpointer _tmp0_ = NULL;
		gpointer _tmp1_;
		gpointer _tmp2_;
		_tmp1_ = _data27_->func (_data27_->func_target, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		((_data27_->_result_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_data27_->_result_ = (g_destroy_func (_data27_->_result_), NULL));
		_data27_->_result_ = _tmp2_;
		((_tmp0_ == NULL) || (g_destroy_func == NULL)) ? NULL : (_tmp0_ = (g_destroy_func (_tmp0_), NULL));
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _g_error_copy0 (_tmp3_);
		_g_error_free0 (_data27_->_error_);
		_data27_->_error_ = _tmp4_;
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _thread_service_run_in_thread_co_gsource_func, _data27_->_async_data_, NULL);
}

static void
___lambda46__worker_func (gpointer self)
{
	__lambda46_ (self);
}

static gboolean
thread_service_run_in_thread_co (ThreadServiceRunInThreadData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data27_ = g_slice_new0 (Block27Data);
	_data_->_data27_->_ref_count_ = 1;
	_data_->_data27_->g_type = _data_->g_type;
	_data_->_data27_->g_dup_func = _data_->g_dup_func;
	_data_->_data27_->g_destroy_func = _data_->g_destroy_func;
	(_data_->_data27_->func_target_destroy_notify == NULL) ? NULL : (_data_->_data27_->func_target_destroy_notify (_data_->_data27_->func_target), NULL);
	_data_->_data27_->func = NULL;
	_data_->_data27_->func_target = NULL;
	_data_->_data27_->func_target_destroy_notify = NULL;
	_data_->_data27_->func = _data_->func;
	_data_->_data27_->func_target = _data_->func_target;
	_data_->_data27_->func_target_destroy_notify = _data_->func_target_destroy_notify;
	_data_->_data27_->_async_data_ = _data_;
	{
		_data_->_tmp1_ = _thread_service_get_thread_pool (&_data_->_inner_error0_);
		_data_->_tmp0_ = _data_->_tmp1_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			if (_data_->_inner_error0_->domain == G_THREAD_ERROR) {
				goto __catch0_g_thread_error;
			}
			block27_data_unref (_data_->_data27_);
			_data_->_data27_ = NULL;
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->thread_pool = _data_->_tmp0_;
	}
	goto __finally0;
	__catch0_g_thread_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp2_ = _data_->e;
		_data_->_tmp3_ = _g_error_copy0 (_data_->_tmp2_);
		_data_->_inner_error0_ = _data_->_tmp3_;
		_g_error_free0 (_data_->e);
		goto __finally0;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block27_data_unref (_data_->_data27_);
		_data_->_data27_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_data27_->_result_ = NULL;
	_data_->_data27_->_error_ = NULL;
	_data_->_tmp4_ = worker_new (___lambda46__worker_func, block27_data_ref (_data_->_data27_), block27_data_unref);
	g_thread_pool_push (_data_->thread_pool, _data_->_tmp4_, &_data_->_inner_error0_);
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block27_data_unref (_data_->_data27_);
		_data_->_data27_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_data_->_tmp5_ = _data_->_data27_->_error_;
	if (_data_->_tmp5_ != NULL) {
		_data_->_tmp6_ = _data_->_data27_->_error_;
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
		_data_->_inner_error0_ = _data_->_tmp7_;
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
		block27_data_unref (_data_->_data27_);
		_data_->_data27_ = NULL;
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp8_ = _data_->_data27_->_result_;
	_data_->_tmp9_ = ((_data_->_tmp8_ != NULL) && (_data_->g_dup_func != NULL)) ? _data_->g_dup_func ((gpointer) _data_->_tmp8_) : ((gpointer) _data_->_tmp8_);
	_data_->result = _data_->_tmp9_;
	block27_data_unref (_data_->_data27_);
	_data_->_data27_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

