/* screenshot_cache.c generated by valac 0.56.13, the Vala compiler
 * generated from screenshot_cache.vala, do not modify */

/* core/screenshot_cache.vala
 *
 * Copyright 2022 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* Adapted from elementary OS AppCentre*/

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>

#define CATALOGUE_CORE_SCREENSHOT_CACHE_HTTP_HEAD_TIMEOUT 3000
#define CATALOGUE_CORE_SCREENSHOT_CACHE_HTTP_DOWNLOAD_TIMEOUT 5000
#define CATALOGUE_CORE_SCREENSHOT_CACHE_MAX_CACHE_SIZE 100000000
#define CONFIG_APP_ID "com.fyralabs.Catalogue"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE (catalogue_core_screenshot_cache_get_type ())
#define CATALOGUE_CORE_SCREENSHOT_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE, CatalogueCoreScreenshotCache))
#define CATALOGUE_CORE_SCREENSHOT_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE, CatalogueCoreScreenshotCacheClass))
#define CATALOGUE_CORE_IS_SCREENSHOT_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE))
#define CATALOGUE_CORE_IS_SCREENSHOT_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE))
#define CATALOGUE_CORE_SCREENSHOT_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE, CatalogueCoreScreenshotCacheClass))

typedef struct _CatalogueCoreScreenshotCache CatalogueCoreScreenshotCache;
typedef struct _CatalogueCoreScreenshotCacheClass CatalogueCoreScreenshotCacheClass;
typedef struct _CatalogueCoreScreenshotCachePrivate CatalogueCoreScreenshotCachePrivate;
enum  {
	CATALOGUE_CORE_SCREENSHOT_CACHE_0_PROPERTY,
	CATALOGUE_CORE_SCREENSHOT_CACHE_NUM_PROPERTIES
};
static GParamSpec* catalogue_core_screenshot_cache_properties[CATALOGUE_CORE_SCREENSHOT_CACHE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _CatalogueCoreScreenshotCacheMaintainData CatalogueCoreScreenshotCacheMaintainData;
typedef struct _CatalogueCoreScreenshotCacheDeleteOldestFilesData CatalogueCoreScreenshotCacheDeleteOldestFilesData;
typedef struct _Block44Data Block44Data;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block45Data Block45Data;
typedef struct _CatalogueCoreScreenshotCacheFetchData CatalogueCoreScreenshotCacheFetchData;

struct _CatalogueCoreScreenshotCache {
	GObject parent_instance;
	CatalogueCoreScreenshotCachePrivate * priv;
};

struct _CatalogueCoreScreenshotCacheClass {
	GObjectClass parent_class;
};

struct _CatalogueCoreScreenshotCachePrivate {
	GFile* screenshot_folder;
};

struct _CatalogueCoreScreenshotCacheMaintainData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CatalogueCoreScreenshotCache* self;
	guint64 screenshot_usage;
	guint64 dirs;
	guint64 files;
	gboolean _tmp0_;
	GFile* _tmp1_;
	guint64 _tmp2_;
	guint64 _tmp3_;
	guint64 _tmp4_;
	gboolean _tmp5_;
	GError* e;
	GError* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GError* _inner_error0_;
};

struct _CatalogueCoreScreenshotCacheDeleteOldestFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CatalogueCoreScreenshotCache* self;
	guint64 screenshot_usage;
	GeeArrayList* file_list;
	GeeArrayList* _tmp0_;
	GFileEnumerator* enumerator;
	GFileEnumerator* _tmp1_;
	GFile* _tmp2_;
	GFileEnumerator* _tmp3_;
	GFileEnumerator* _tmp4_;
	GError* e;
	GError* _tmp5_;
	const gchar* _tmp6_;
	GFileInfo* info;
	GFileInfo* _tmp7_;
	GFileEnumerator* _tmp8_;
	GFileInfo* _tmp9_;
	GFileInfo* _tmp10_;
	GFileInfo* _tmp11_;
	GFileInfo* _tmp12_;
	GeeArrayList* _tmp13_;
	GFileInfo* _tmp14_;
	GError* _vala1_e;
	GError* _tmp15_;
	const gchar* _tmp16_;
	GeeArrayList* _tmp17_;
	guint64 current_usage;
	GeeArrayList* _file_info_list;
	GeeArrayList* _tmp18_;
	gint _file_info_size;
	GeeArrayList* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _file_info_index;
	gint _tmp22_;
	gint _tmp23_;
	GFileInfo* file_info;
	GeeArrayList* _tmp24_;
	gpointer _tmp25_;
	GFile* file;
	GFile* _tmp26_;
	GFileInfo* _tmp27_;
	const gchar* _tmp28_;
	GFile* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GFile* _tmp34_;
	GFileInfo* _tmp35_;
	GError* _vala2_e;
	GFile* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GError* _tmp39_;
	const gchar* _tmp40_;
	GError* _inner_error0_;
};

struct _Block44Data {
	int _ref_count_;
	CatalogueCoreScreenshotCache* self;
	GCancellable* cancellable;
	guint cancel_source;
};

struct _Block45Data {
	int _ref_count_;
	CatalogueCoreScreenshotCache* self;
	GCancellable* cancellable;
	guint cancel_source;
};

struct _CatalogueCoreScreenshotCacheFetchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	CatalogueCoreScreenshotCache* self;
	gchar* url;
	gchar* path;
	gboolean result;
	gchar* _tmp0_;
	GFile* remote_file;
	GFile* _tmp1_;
	GFile* local_file;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GDateTime* remote_mtime;
	Block44Data* _data44_;
	GCancellable* _tmp4_;
	GFileInfo* file_info;
	GFile* _tmp5_;
	GCancellable* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
	GDateTime* _tmp9_;
	GError* e;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GFile* _tmp12_;
	GDateTime* file_time;
	GFileInfo* _vala1_file_info;
	GFile* _tmp13_;
	GFileInfo* _tmp14_;
	GFileInfo* _tmp15_;
	GDateTime* _tmp16_;
	GError* _vala1_e;
	GError* _tmp17_;
	const gchar* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GDateTime* _tmp21_;
	GDateTime* _tmp22_;
	GDateTime* _tmp23_;
	GDateTime* _tmp24_;
	Block45Data* _data45_;
	GCancellable* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	GCancellable* _tmp28_;
	GError* _vala2_e;
	GError* _tmp29_;
	const gchar* _tmp30_;
	GError* _inner_error0_;
};

static gint CatalogueCoreScreenshotCache_private_offset;
static gpointer catalogue_core_screenshot_cache_parent_class = NULL;

VALA_EXTERN GType catalogue_core_screenshot_cache_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CatalogueCoreScreenshotCache, g_object_unref)
static void catalogue_core_screenshot_cache_maintain_data_free (gpointer _data);
static void catalogue_core_screenshot_cache_maintain (CatalogueCoreScreenshotCache* self,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_);
static void catalogue_core_screenshot_cache_maintain_finish (CatalogueCoreScreenshotCache* self,
                                                      GAsyncResult* _res_);
static gboolean catalogue_core_screenshot_cache_maintain_co (CatalogueCoreScreenshotCacheMaintainData* _data_);
static void catalogue_core_screenshot_cache_maintain_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_);
static void catalogue_core_screenshot_cache_delete_oldest_files (CatalogueCoreScreenshotCache* self,
                                                          guint64 screenshot_usage,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
static void catalogue_core_screenshot_cache_delete_oldest_files_finish (CatalogueCoreScreenshotCache* self,
                                                                 GAsyncResult* _res_);
static void catalogue_core_screenshot_cache_delete_oldest_files_data_free (gpointer _data);
static gboolean catalogue_core_screenshot_cache_delete_oldest_files_co (CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_);
static void catalogue_core_screenshot_cache_delete_oldest_files_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static gint __lambda39_ (CatalogueCoreScreenshotCache* self,
                  GFileInfo* a,
                  GFileInfo* b);
static gint ___lambda39__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static gchar* catalogue_core_screenshot_cache_generate_screenshot_path (CatalogueCoreScreenshotCache* self,
                                                                 const gchar* url);
static void catalogue_core_screenshot_cache_fetch_data_free (gpointer _data);
VALA_EXTERN void catalogue_core_screenshot_cache_fetch (CatalogueCoreScreenshotCache* self,
                                            const gchar* url,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
VALA_EXTERN gboolean catalogue_core_screenshot_cache_fetch_finish (CatalogueCoreScreenshotCache* self,
                                                       GAsyncResult* _res_,
                                                       gchar** path);
static gboolean catalogue_core_screenshot_cache_fetch_co (CatalogueCoreScreenshotCacheFetchData* _data_);
static Block44Data* block44_data_ref (Block44Data* _data44_);
static void block44_data_unref (void * _userdata_);
static gboolean ___lambda40_ (Block44Data* _data44_);
static gboolean ____lambda40__gsource_func (gpointer self);
static void catalogue_core_screenshot_cache_fetch_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static GDateTime* catalogue_core_screenshot_cache_get_modification_time (GFileInfo* info);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static gboolean ___lambda41_ (Block45Data* _data45_);
static gboolean ____lambda41__gsource_func (gpointer self);
VALA_EXTERN CatalogueCoreScreenshotCache* catalogue_core_screenshot_cache_new (void);
VALA_EXTERN CatalogueCoreScreenshotCache* catalogue_core_screenshot_cache_construct (GType object_type);
static GObject * catalogue_core_screenshot_cache_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static void catalogue_core_screenshot_cache_finalize (GObject * obj);
static GType catalogue_core_screenshot_cache_get_type_once (void);

static inline gpointer
catalogue_core_screenshot_cache_get_instance_private (CatalogueCoreScreenshotCache* self)
{
	return G_STRUCT_MEMBER_P (self, CatalogueCoreScreenshotCache_private_offset);
}

static void
catalogue_core_screenshot_cache_maintain_data_free (gpointer _data)
{
	CatalogueCoreScreenshotCacheMaintainData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (CatalogueCoreScreenshotCacheMaintainData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
catalogue_core_screenshot_cache_maintain (CatalogueCoreScreenshotCache* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheMaintainData* _data_;
	CatalogueCoreScreenshotCache* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (CatalogueCoreScreenshotCacheMaintainData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, catalogue_core_screenshot_cache_maintain_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	catalogue_core_screenshot_cache_maintain_co (_data_);
}

static void
catalogue_core_screenshot_cache_maintain_finish (CatalogueCoreScreenshotCache* self,
                                                 GAsyncResult* _res_)
{
	CatalogueCoreScreenshotCacheMaintainData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
catalogue_core_screenshot_cache_maintain_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheMaintainData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	catalogue_core_screenshot_cache_maintain_co (_data_);
}

static gboolean
catalogue_core_screenshot_cache_maintain_co (CatalogueCoreScreenshotCacheMaintainData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->screenshot_usage = (guint64) 0;
	_data_->dirs = (guint64) 0;
	_data_->files = (guint64) 0;
	{
		_data_->_tmp1_ = _data_->self->priv->screenshot_folder;
		_data_->_tmp2_ = 0ULL;
		_data_->_tmp3_ = 0ULL;
		_data_->_tmp4_ = 0ULL;
		_data_->_state_ = 1;
		g_file_measure_disk_usage_async (_data_->_tmp1_, G_FILE_MEASURE_NONE, G_PRIORITY_DEFAULT, NULL, NULL, NULL, catalogue_core_screenshot_cache_maintain_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp5_ = g_file_measure_disk_usage_finish (_data_->_tmp1_, _data_->_res_, &_data_->_tmp2_, &_data_->_tmp3_, &_data_->_tmp4_, &_data_->_inner_error0_);
		_data_->screenshot_usage = _data_->_tmp2_;
		_data_->dirs = _data_->_tmp3_;
		_data_->files = _data_->_tmp4_;
		_data_->_tmp0_ = _data_->_tmp5_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (!_data_->_tmp0_) {
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp6_ = _data_->e;
		_data_->_tmp7_ = _data_->_tmp6_->message;
		g_warning ("screenshot_cache.vala:71: Error measuring size of screenshot cache: %s", _data_->_tmp7_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp8_ = g_format_size_full (_data_->screenshot_usage, G_FORMAT_SIZE_DEFAULT);
	_data_->_tmp9_ = _data_->_tmp8_;
	g_debug ("screenshot_cache.vala:74: Screenshot folder size is %s", _data_->_tmp9_);
	_g_free0 (_data_->_tmp9_);
	if (_data_->screenshot_usage > ((guint64) CATALOGUE_CORE_SCREENSHOT_CACHE_MAX_CACHE_SIZE)) {
		_data_->_state_ = 2;
		catalogue_core_screenshot_cache_delete_oldest_files (_data_->self, _data_->screenshot_usage, catalogue_core_screenshot_cache_maintain_ready, _data_);
		return FALSE;
		_state_2:
		catalogue_core_screenshot_cache_delete_oldest_files_finish (_data_->self, _data_->_res_);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
catalogue_core_screenshot_cache_delete_oldest_files_data_free (gpointer _data)
{
	CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (CatalogueCoreScreenshotCacheDeleteOldestFilesData, _data_);
}

static void
catalogue_core_screenshot_cache_delete_oldest_files (CatalogueCoreScreenshotCache* self,
                                                     guint64 screenshot_usage,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_;
	CatalogueCoreScreenshotCache* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (CatalogueCoreScreenshotCacheDeleteOldestFilesData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, catalogue_core_screenshot_cache_delete_oldest_files_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->screenshot_usage = screenshot_usage;
	catalogue_core_screenshot_cache_delete_oldest_files_co (_data_);
}

static void
catalogue_core_screenshot_cache_delete_oldest_files_finish (CatalogueCoreScreenshotCache* self,
                                                            GAsyncResult* _res_)
{
	CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
catalogue_core_screenshot_cache_delete_oldest_files_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	catalogue_core_screenshot_cache_delete_oldest_files_co (_data_);
}

static gint
__lambda39_ (CatalogueCoreScreenshotCache* self,
             GFileInfo* a,
             GFileInfo* b)
{
	guint64 a_time = 0ULL;
	guint64 b_time = 0ULL;
	gint result;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	a_time = g_file_info_get_attribute_uint64 (a, G_FILE_ATTRIBUTE_TIME_CHANGED);
	b_time = g_file_info_get_attribute_uint64 (b, G_FILE_ATTRIBUTE_TIME_CHANGED);
	if (a_time < b_time) {
		result = -1;
		return result;
	} else {
		if (a_time == b_time) {
			result = 0;
			return result;
		} else {
			result = 1;
			return result;
		}
	}
}

static gint
___lambda39__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda39_ ((CatalogueCoreScreenshotCache*) self, (GFileInfo*) a, (GFileInfo*) b);
	return result;
}

static gboolean
catalogue_core_screenshot_cache_delete_oldest_files_co (CatalogueCoreScreenshotCacheDeleteOldestFilesData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = gee_array_list_new (g_file_info_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_data_->file_list = _data_->_tmp0_;
	{
		_data_->_tmp2_ = _data_->self->priv->screenshot_folder;
		_data_->_state_ = 1;
		g_file_enumerate_children_async (_data_->_tmp2_, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_TIME_CHANGED, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, catalogue_core_screenshot_cache_delete_oldest_files_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = g_file_enumerate_children_finish (_data_->_tmp2_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp1_ = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp4_ = _data_->_tmp1_;
		_data_->_tmp1_ = NULL;
		_g_object_unref0 (_data_->enumerator);
		_data_->enumerator = _data_->_tmp4_;
		_g_object_unref0 (_data_->_tmp1_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp5_ = _data_->e;
		_data_->_tmp6_ = _data_->_tmp5_->message;
		g_warning ("screenshot_cache.vala:95: Unable to create enumerator to delete cached" \
" screenshots: %s", _data_->_tmp6_);
		_g_error_free0 (_data_->e);
		_g_object_unref0 (_data_->enumerator);
		_g_object_unref0 (_data_->file_list);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->enumerator);
		_g_object_unref0 (_data_->file_list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	{
		while (TRUE) {
			_data_->_tmp8_ = _data_->enumerator;
			_data_->_tmp9_ = g_file_enumerator_next_file (_data_->_tmp8_, NULL, &_data_->_inner_error0_);
			_data_->_tmp7_ = _data_->_tmp9_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_data_->_tmp10_ = _data_->_tmp7_;
			_data_->_tmp7_ = NULL;
			_g_object_unref0 (_data_->info);
			_data_->info = _data_->_tmp10_;
			_data_->_tmp11_ = _data_->info;
			if (!(_data_->_tmp11_ != NULL)) {
				_g_object_unref0 (_data_->_tmp7_);
				break;
			}
			_data_->_tmp12_ = _data_->info;
			if (g_file_info_get_file_type (_data_->_tmp12_) == G_FILE_TYPE_REGULAR) {
				_data_->_tmp13_ = _data_->file_list;
				_data_->_tmp14_ = _data_->info;
				gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp13_, _data_->_tmp14_);
			}
			_g_object_unref0 (_data_->_tmp7_);
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		_data_->_vala1_e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp15_ = _data_->_vala1_e;
		_data_->_tmp16_ = _data_->_tmp15_->message;
		g_warning ("screenshot_cache.vala:109: Error while enumerating screenshot cache di" \
"r: %s", _data_->_tmp16_);
		_g_error_free0 (_data_->_vala1_e);
	}
	__finally1:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_object_unref0 (_data_->info);
		_g_object_unref0 (_data_->enumerator);
		_g_object_unref0 (_data_->file_list);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp17_ = _data_->file_list;
	gee_list_sort ((GeeList*) _data_->_tmp17_, ___lambda39__gcompare_data_func, g_object_ref (_data_->self), g_object_unref);
	_data_->current_usage = _data_->screenshot_usage;
	{
		_data_->_tmp18_ = _data_->file_list;
		_data_->_file_info_list = _data_->_tmp18_;
		_data_->_tmp19_ = _data_->_file_info_list;
		_data_->_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp19_);
		_data_->_tmp21_ = _data_->_tmp20_;
		_data_->_file_info_size = _data_->_tmp21_;
		_data_->_file_info_index = -1;
		while (TRUE) {
			_data_->_file_info_index = _data_->_file_info_index + 1;
			_data_->_tmp22_ = _data_->_file_info_index;
			_data_->_tmp23_ = _data_->_file_info_size;
			if (!(_data_->_tmp22_ < _data_->_tmp23_)) {
				break;
			}
			_data_->_tmp24_ = _data_->_file_info_list;
			_data_->_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp24_, _data_->_file_info_index);
			_data_->file_info = (GFileInfo*) _data_->_tmp25_;
			if (_data_->current_usage > ((guint64) CATALOGUE_CORE_SCREENSHOT_CACHE_MAX_CACHE_SIZE)) {
				_data_->_tmp26_ = _data_->self->priv->screenshot_folder;
				_data_->_tmp27_ = _data_->file_info;
				_data_->_tmp28_ = g_file_info_get_name (_data_->_tmp27_);
				_data_->_tmp29_ = g_file_resolve_relative_path (_data_->_tmp26_, _data_->_tmp28_);
				_data_->file = _data_->_tmp29_;
				_data_->_tmp30_ = _data_->file;
				if (_data_->_tmp30_ == NULL) {
					_g_object_unref0 (_data_->file);
					_g_object_unref0 (_data_->file_info);
					continue;
				}
				_data_->_tmp31_ = _data_->file;
				_data_->_tmp32_ = g_file_get_path (_data_->_tmp31_);
				_data_->_tmp33_ = _data_->_tmp32_;
				g_debug ("screenshot_cache.vala:135: deleting screenshot at %s to free cache", _data_->_tmp33_);
				_g_free0 (_data_->_tmp33_);
				{
					_data_->_tmp34_ = _data_->file;
					_data_->_state_ = 2;
					g_file_delete_async (_data_->_tmp34_, G_PRIORITY_DEFAULT, NULL, catalogue_core_screenshot_cache_delete_oldest_files_ready, _data_);
					return FALSE;
					_state_2:
					g_file_delete_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error0_);
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
						goto __catch2_g_error;
					}
					_data_->_tmp35_ = _data_->file_info;
					_data_->current_usage -= (guint64) g_file_info_get_size (_data_->_tmp35_);
				}
				goto __finally2;
				__catch2_g_error:
				{
					_data_->_vala2_e = _data_->_inner_error0_;
					_data_->_inner_error0_ = NULL;
					_data_->_tmp36_ = _data_->file;
					_data_->_tmp37_ = g_file_get_path (_data_->_tmp36_);
					_data_->_tmp38_ = _data_->_tmp37_;
					_data_->_tmp39_ = _data_->_vala2_e;
					_data_->_tmp40_ = _data_->_tmp39_->message;
					g_warning ("screenshot_cache.vala:140: Unable to delete cached screenshot file '%s" \
"': %s", _data_->_tmp38_, _data_->_tmp40_);
					_g_free0 (_data_->_tmp38_);
					_g_error_free0 (_data_->_vala2_e);
				}
				__finally2:
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					_g_object_unref0 (_data_->file);
					_g_object_unref0 (_data_->file_info);
					_g_object_unref0 (_data_->info);
					_g_object_unref0 (_data_->enumerator);
					_g_object_unref0 (_data_->file_list);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
					g_clear_error (&_data_->_inner_error0_);
					g_object_unref (_data_->_async_result);
					return FALSE;
				}
				_g_object_unref0 (_data_->file);
			} else {
				_g_object_unref0 (_data_->file_info);
				break;
			}
			_g_object_unref0 (_data_->file_info);
		}
	}
	_g_object_unref0 (_data_->info);
	_g_object_unref0 (_data_->enumerator);
	_g_object_unref0 (_data_->file_list);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (needle != NULL, 0);
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	if (_tmp1_ != NULL) {
		gchar* _tmp2_;
		_tmp2_ = _result_;
		result = (gint) (_tmp2_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = strlen (self);
	_tmp1_ = _tmp0_;
	string_length = (glong) _tmp1_;
	if (start < ((glong) 0)) {
		start = string_length + start;
	}
	if (end < ((glong) 0)) {
		end = string_length + end;
	}
	if (start >= ((glong) 0)) {
		_tmp2_ = start <= string_length;
	} else {
		_tmp2_ = FALSE;
	}
	g_return_val_if_fail (_tmp2_, NULL);
	if (end >= ((glong) 0)) {
		_tmp3_ = end <= string_length;
	} else {
		_tmp3_ = FALSE;
	}
	g_return_val_if_fail (_tmp3_, NULL);
	g_return_val_if_fail (start <= end, NULL);
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
	result = _tmp4_;
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static gchar*
catalogue_core_screenshot_cache_generate_screenshot_path (CatalogueCoreScreenshotCache* self,
                                                          const gchar* url)
{
	gint ext_pos = 0;
	gchar* extension = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	ext_pos = string_last_index_of (url, ".", 0);
	_tmp0_ = strlen (url);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_slice (url, (glong) ext_pos, (glong) _tmp1_);
	extension = _tmp2_;
	_tmp3_ = extension;
	if (string_contains (_tmp3_, "/")) {
		gchar* _tmp4_;
		_tmp4_ = g_strdup ("");
		_g_free0 (extension);
		extension = _tmp4_;
	}
	_tmp5_ = self->priv->screenshot_folder;
	_tmp6_ = g_file_get_path (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strdup_printf ("%02x", g_str_hash (url));
	_tmp9_ = _tmp8_;
	_tmp10_ = extension;
	_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_build_filename (_tmp7_, _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_g_free0 (_tmp12_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	result = _tmp14_;
	_g_free0 (extension);
	return result;
}

static void
catalogue_core_screenshot_cache_fetch_data_free (gpointer _data)
{
	CatalogueCoreScreenshotCacheFetchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->url);
	_g_object_unref0 (_data_->self);
	g_slice_free (CatalogueCoreScreenshotCacheFetchData, _data_);
}

void
catalogue_core_screenshot_cache_fetch (CatalogueCoreScreenshotCache* self,
                                       const gchar* url,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheFetchData* _data_;
	CatalogueCoreScreenshotCache* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (url != NULL);
	_data_ = g_slice_new0 (CatalogueCoreScreenshotCacheFetchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, catalogue_core_screenshot_cache_fetch_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (url);
	_g_free0 (_data_->url);
	_data_->url = _tmp1_;
	catalogue_core_screenshot_cache_fetch_co (_data_);
}

gboolean
catalogue_core_screenshot_cache_fetch_finish (CatalogueCoreScreenshotCache* self,
                                              GAsyncResult* _res_,
                                              gchar** path)
{
	gboolean result;
	CatalogueCoreScreenshotCacheFetchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	if (path) {
		*path = _data_->path;
	} else {
		_g_free0 (_data_->path);
	}
	_data_->path = NULL;
	result = _data_->result;
	return result;
}

static Block44Data*
block44_data_ref (Block44Data* _data44_)
{
	g_atomic_int_inc (&_data44_->_ref_count_);
	return _data44_;
}

static void
block44_data_unref (void * _userdata_)
{
	Block44Data* _data44_;
	_data44_ = (Block44Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data44_->_ref_count_)) {
		CatalogueCoreScreenshotCache* self;
		self = _data44_->self;
		_g_object_unref0 (_data44_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block44Data, _data44_);
	}
}

static gboolean
___lambda40_ (Block44Data* _data44_)
{
	CatalogueCoreScreenshotCache* self;
	GCancellable* _tmp0_;
	gboolean result;
	self = _data44_->self;
	_data44_->cancel_source = (guint) 0;
	_tmp0_ = _data44_->cancellable;
	g_cancellable_cancel (_tmp0_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda40__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda40_ (self);
	return result;
}

static void
catalogue_core_screenshot_cache_fetch_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	CatalogueCoreScreenshotCacheFetchData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	catalogue_core_screenshot_cache_fetch_co (_data_);
}

static Block45Data*
block45_data_ref (Block45Data* _data45_)
{
	g_atomic_int_inc (&_data45_->_ref_count_);
	return _data45_;
}

static void
block45_data_unref (void * _userdata_)
{
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
		CatalogueCoreScreenshotCache* self;
		self = _data45_->self;
		_g_object_unref0 (_data45_->cancellable);
		_g_object_unref0 (self);
		g_slice_free (Block45Data, _data45_);
	}
}

static gboolean
___lambda41_ (Block45Data* _data45_)
{
	CatalogueCoreScreenshotCache* self;
	GCancellable* _tmp0_;
	gboolean result;
	self = _data45_->self;
	_data45_->cancel_source = (guint) 0;
	_tmp0_ = _data45_->cancellable;
	g_cancellable_cancel (_tmp0_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda41__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda41_ (self);
	return result;
}

static gboolean
catalogue_core_screenshot_cache_fetch_co (CatalogueCoreScreenshotCacheFetchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = catalogue_core_screenshot_cache_generate_screenshot_path (_data_->self, _data_->url);
	_g_free0 (_data_->path);
	_data_->path = _data_->_tmp0_;
	_data_->_tmp1_ = g_file_new_for_uri (_data_->url);
	_data_->remote_file = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->path;
	_data_->_tmp3_ = g_file_new_for_path (_data_->_tmp2_);
	_data_->local_file = _data_->_tmp3_;
	_data_->remote_mtime = NULL;
	{
		_data_->_data44_ = g_slice_new0 (Block44Data);
		_data_->_data44_->_ref_count_ = 1;
		_data_->_data44_->self = g_object_ref (_data_->self);
		_data_->_tmp4_ = g_cancellable_new ();
		_data_->_data44_->cancellable = _data_->_tmp4_;
		_data_->_data44_->cancel_source = (guint) 0;
		_data_->_data44_->cancel_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) CATALOGUE_CORE_SCREENSHOT_CACHE_HTTP_HEAD_TIMEOUT, ____lambda40__gsource_func, block44_data_ref (_data_->_data44_), block44_data_unref);
		_data_->_tmp5_ = _data_->remote_file;
		_data_->_tmp6_ = _data_->_data44_->cancellable;
		_data_->_state_ = 1;
		g_file_query_info_async (_data_->_tmp5_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->_tmp6_, catalogue_core_screenshot_cache_fetch_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp7_ = g_file_query_info_finish (_data_->_tmp5_, _data_->_res_, &_data_->_inner_error0_);
		_data_->file_info = _data_->_tmp7_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			block44_data_unref (_data_->_data44_);
			_data_->_data44_ = NULL;
			goto __catch0_g_error;
		}
		if (_data_->_data44_->cancel_source != ((guint) 0)) {
			g_source_remove (_data_->_data44_->cancel_source);
		}
		_data_->_tmp8_ = _data_->file_info;
		_data_->_tmp9_ = catalogue_core_screenshot_cache_get_modification_time (_data_->_tmp8_);
		_g_date_time_unref0 (_data_->remote_mtime);
		_data_->remote_mtime = _data_->_tmp9_;
		_g_object_unref0 (_data_->file_info);
		block44_data_unref (_data_->_data44_);
		_data_->_data44_ = NULL;
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp10_ = _data_->e;
		_data_->_tmp11_ = _data_->_tmp10_->message;
		g_warning ("screenshot_cache.vala:195: Error getting modification time of remote s" \
"creenshot file: %s", _data_->_tmp11_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_date_time_unref0 (_data_->remote_mtime);
		_g_object_unref0 (_data_->local_file);
		_g_object_unref0 (_data_->remote_file);
		_g_free0 (_data_->path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->_tmp12_ = _data_->local_file;
	if (g_file_query_exists (_data_->_tmp12_, NULL)) {
		_data_->file_time = NULL;
		{
			_data_->_tmp13_ = _data_->local_file;
			_data_->_state_ = 2;
			g_file_query_info_async (_data_->_tmp13_, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, catalogue_core_screenshot_cache_fetch_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp14_ = g_file_query_info_finish (_data_->_tmp13_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_vala1_file_info = _data_->_tmp14_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_data_->_tmp15_ = _data_->_vala1_file_info;
			_data_->_tmp16_ = catalogue_core_screenshot_cache_get_modification_time (_data_->_tmp15_);
			_g_date_time_unref0 (_data_->file_time);
			_data_->file_time = _data_->_tmp16_;
			_g_object_unref0 (_data_->_vala1_file_info);
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1_e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp17_ = _data_->_vala1_e;
			_data_->_tmp18_ = _data_->_tmp17_->message;
			g_warning ("screenshot_cache.vala:204: Error getting modification time of cached s" \
"creenshot file: %s", _data_->_tmp18_);
			_g_error_free0 (_data_->_vala1_e);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_date_time_unref0 (_data_->file_time);
			_g_date_time_unref0 (_data_->remote_mtime);
			_g_object_unref0 (_data_->local_file);
			_g_object_unref0 (_data_->remote_file);
			_g_free0 (_data_->path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp21_ = _data_->file_time;
		if (_data_->_tmp21_ != NULL) {
			_data_->_tmp22_ = _data_->remote_mtime;
			_data_->_tmp20_ = _data_->_tmp22_ != NULL;
		} else {
			_data_->_tmp20_ = FALSE;
		}
		if (_data_->_tmp20_) {
			_data_->_tmp23_ = _data_->file_time;
			_data_->_tmp24_ = _data_->remote_mtime;
			_data_->_tmp19_ = g_date_time_equal (_data_->_tmp23_, _data_->_tmp24_);
		} else {
			_data_->_tmp19_ = FALSE;
		}
		if (_data_->_tmp19_) {
			_data_->result = TRUE;
			_g_date_time_unref0 (_data_->file_time);
			_g_date_time_unref0 (_data_->remote_mtime);
			_g_object_unref0 (_data_->local_file);
			_g_object_unref0 (_data_->remote_file);
			g_task_return_pointer (_data_->_async_result, _data_, NULL);
			if (_data_->_state_ != 0) {
				while (!g_task_get_completed (_data_->_async_result)) {
					g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
				}
			}
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_date_time_unref0 (_data_->file_time);
	}
	{
		_data_->_data45_ = g_slice_new0 (Block45Data);
		_data_->_data45_->_ref_count_ = 1;
		_data_->_data45_->self = g_object_ref (_data_->self);
		_data_->_tmp25_ = g_cancellable_new ();
		_data_->_data45_->cancellable = _data_->_tmp25_;
		_data_->_data45_->cancel_source = (guint) 0;
		_data_->_data45_->cancel_source = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) CATALOGUE_CORE_SCREENSHOT_CACHE_HTTP_DOWNLOAD_TIMEOUT, ____lambda41__gsource_func, block45_data_ref (_data_->_data45_), block45_data_unref);
		_data_->_tmp26_ = _data_->remote_file;
		_data_->_tmp27_ = _data_->local_file;
		_data_->_tmp28_ = _data_->_data45_->cancellable;
		_data_->_state_ = 3;
		g_file_copy_async (_data_->_tmp26_, _data_->_tmp27_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, G_PRIORITY_DEFAULT, _data_->_tmp28_, NULL, NULL, catalogue_core_screenshot_cache_fetch_ready, _data_);
		return FALSE;
		_state_3:
		g_file_copy_finish (_data_->_tmp26_, _data_->_res_, &_data_->_inner_error0_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			block45_data_unref (_data_->_data45_);
			_data_->_data45_ = NULL;
			goto __catch2_g_error;
		}
		if (_data_->_data45_->cancel_source != ((guint) 0)) {
			g_source_remove (_data_->_data45_->cancel_source);
		}
		block45_data_unref (_data_->_data45_);
		_data_->_data45_ = NULL;
	}
	goto __finally2;
	__catch2_g_error:
	{
		_data_->_vala2_e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp29_ = _data_->_vala2_e;
		_data_->_tmp30_ = _data_->_tmp29_->message;
		g_warning ("screenshot_cache.vala:234: Unable to download screenshot from %s: %s", _data_->url, _data_->_tmp30_);
		_data_->result = FALSE;
		_g_error_free0 (_data_->_vala2_e);
		_g_date_time_unref0 (_data_->remote_mtime);
		_g_object_unref0 (_data_->local_file);
		_g_object_unref0 (_data_->remote_file);
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
		if (_data_->_state_ != 0) {
			while (!g_task_get_completed (_data_->_async_result)) {
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
			}
		}
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	__finally2:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_date_time_unref0 (_data_->remote_mtime);
		_g_object_unref0 (_data_->local_file);
		_g_object_unref0 (_data_->remote_file);
		_g_free0 (_data_->path);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_data_->result = TRUE;
	_g_date_time_unref0 (_data_->remote_mtime);
	_g_object_unref0 (_data_->local_file);
	_g_object_unref0 (_data_->remote_file);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static GDateTime*
catalogue_core_screenshot_cache_get_modification_time (GFileInfo* info)
{
	GDateTime* datetime = NULL;
	GDateTime* _tmp0_;
	GDateTime* result;
	g_return_val_if_fail (info != NULL, NULL);
	datetime = NULL;
	_tmp0_ = g_file_info_get_modification_date_time (info);
	_g_date_time_unref0 (datetime);
	datetime = _tmp0_;
	result = datetime;
	return result;
}

CatalogueCoreScreenshotCache*
catalogue_core_screenshot_cache_construct (GType object_type)
{
	CatalogueCoreScreenshotCache * self = NULL;
	self = (CatalogueCoreScreenshotCache*) g_object_new (object_type, NULL);
	return self;
}

CatalogueCoreScreenshotCache*
catalogue_core_screenshot_cache_new (void)
{
	return catalogue_core_screenshot_cache_construct (CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE);
}

static GObject *
catalogue_core_screenshot_cache_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	CatalogueCoreScreenshotCache * self;
	gchar* screenshot_path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (catalogue_core_screenshot_cache_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE, CatalogueCoreScreenshotCache);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = g_build_filename (_tmp0_, CONFIG_APP_ID, "screenshots", NULL);
	screenshot_path = _tmp1_;
	_tmp2_ = screenshot_path;
	g_debug ("screenshot_cache.vala:37: screenshot path is at %s", _tmp2_);
	_tmp3_ = screenshot_path;
	_tmp4_ = g_file_new_for_path (_tmp3_);
	_g_object_unref0 (self->priv->screenshot_folder);
	self->priv->screenshot_folder = _tmp4_;
	_tmp5_ = self->priv->screenshot_folder;
	if (!g_file_query_exists (_tmp5_, NULL)) {
		{
			gboolean _tmp6_ = FALSE;
			GFile* _tmp7_;
			_tmp7_ = self->priv->screenshot_folder;
			_tmp6_ = g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			if (!_tmp6_) {
				_g_free0 (screenshot_path);
				return obj;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("screenshot_cache.vala:47: Error creating screenshot cache folder: %s", _tmp9_);
			_g_error_free0 (e);
			_g_free0 (screenshot_path);
			return obj;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (screenshot_path);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
	}
	catalogue_core_screenshot_cache_maintain (self, NULL, NULL);
	_g_free0 (screenshot_path);
	return obj;
}

static void
catalogue_core_screenshot_cache_class_init (CatalogueCoreScreenshotCacheClass * klass,
                                            gpointer klass_data)
{
	catalogue_core_screenshot_cache_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &CatalogueCoreScreenshotCache_private_offset);
	G_OBJECT_CLASS (klass)->constructor = catalogue_core_screenshot_cache_constructor;
	G_OBJECT_CLASS (klass)->finalize = catalogue_core_screenshot_cache_finalize;
}

static void
catalogue_core_screenshot_cache_instance_init (CatalogueCoreScreenshotCache * self,
                                               gpointer klass)
{
	self->priv = catalogue_core_screenshot_cache_get_instance_private (self);
}

static void
catalogue_core_screenshot_cache_finalize (GObject * obj)
{
	CatalogueCoreScreenshotCache * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CATALOGUE_CORE_TYPE_SCREENSHOT_CACHE, CatalogueCoreScreenshotCache);
	_g_object_unref0 (self->priv->screenshot_folder);
	G_OBJECT_CLASS (catalogue_core_screenshot_cache_parent_class)->finalize (obj);
}

static GType
catalogue_core_screenshot_cache_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CatalogueCoreScreenshotCacheClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) catalogue_core_screenshot_cache_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CatalogueCoreScreenshotCache), 0, (GInstanceInitFunc) catalogue_core_screenshot_cache_instance_init, NULL };
	GType catalogue_core_screenshot_cache_type_id;
	catalogue_core_screenshot_cache_type_id = g_type_register_static (G_TYPE_OBJECT, "CatalogueCoreScreenshotCache", &g_define_type_info, 0);
	CatalogueCoreScreenshotCache_private_offset = g_type_add_instance_private (catalogue_core_screenshot_cache_type_id, sizeof (CatalogueCoreScreenshotCachePrivate));
	return catalogue_core_screenshot_cache_type_id;
}

GType
catalogue_core_screenshot_cache_get_type (void)
{
	static volatile gsize catalogue_core_screenshot_cache_type_id__once = 0;
	if (g_once_init_enter (&catalogue_core_screenshot_cache_type_id__once)) {
		GType catalogue_core_screenshot_cache_type_id;
		catalogue_core_screenshot_cache_type_id = catalogue_core_screenshot_cache_get_type_once ();
		g_once_init_leave (&catalogue_core_screenshot_cache_type_id__once, catalogue_core_screenshot_cache_type_id);
	}
	return catalogue_core_screenshot_cache_type_id__once;
}

