/* utils.c generated by valac 0.56.13, the Vala compiler
 * generated from utils.vala, do not modify */

/* core/utils.vala
 *
 * Copyright 2022 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _xmlFreeDoc0(var) ((var == NULL) ? NULL : (var = (xmlFreeDoc (var), NULL)))
#define _xmlXPathFreeObject0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeObject (var), NULL)))
#define _xmlXPathFreeContext0(var) ((var == NULL) ? NULL : (var = (xmlXPathFreeContext (var), NULL)))

VALA_EXTERN guint catalogue_core_get_file_age (GFile* file);
VALA_EXTERN gchar* catalogue_core_unescape_markup (const gchar* escaped_text);
VALA_EXTERN void catalogue_core_delete_folder_contents (GFile* folder,
                                            GCancellable* cancellable);
VALA_EXTERN void catalogue_core_perform_xml_fixups (const gchar* origin_name,
                                        GFile* src_file,
                                        GFile* dest_file);

guint
catalogue_core_get_file_age (GFile* file)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	guint64 mtime = 0ULL;
	GFileInfo* _tmp7_;
	guint64 now = 0ULL;
	time_t _tmp8_;
	GError* _inner_error0_ = NULL;
	guint result;
	g_return_val_if_fail (file != NULL, 0U);
	{
		GFileInfo* _tmp0_ = NULL;
		GFileInfo* _tmp1_;
		GFileInfo* _tmp2_;
		_tmp1_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (info);
		info = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("utils.vala:25: Error while getting file age: %s", _tmp4_);
		result = G_MAXUINT;
		_g_error_free0 (e);
		_g_object_unref0 (info);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		guint _tmp5_ = 0U;
		_g_object_unref0 (info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp5_;
	}
	_tmp6_ = info;
	if (_tmp6_ == NULL) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	_tmp7_ = info;
	mtime = g_file_info_get_attribute_uint64 (_tmp7_, G_FILE_ATTRIBUTE_TIME_MODIFIED);
	_tmp8_ = time (NULL);
	now = (guint64) _tmp8_;
	if (mtime > now) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	if ((now - mtime) > ((guint64) G_MAXUINT)) {
		result = G_MAXUINT;
		_g_object_unref0 (info);
		return result;
	}
	result = (guint) (now - mtime);
	_g_object_unref0 (info);
	return result;
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

gchar*
catalogue_core_unescape_markup (const gchar* escaped_text)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
	g_return_val_if_fail (escaped_text != NULL, NULL);
	_tmp0_ = string_replace (escaped_text, "&amp;", "&");
	_tmp1_ = _tmp0_;
	_tmp2_ = string_replace (_tmp1_, "&lt;", "<");
	_tmp3_ = _tmp2_;
	_tmp4_ = string_replace (_tmp3_, "&gt;", ">");
	_tmp5_ = _tmp4_;
	_tmp6_ = string_replace (_tmp5_, "&#39;", "'");
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	result = _tmp7_;
	return result;
}

void
catalogue_core_delete_folder_contents (GFile* folder,
                                       GCancellable* cancellable)
{
	GFileEnumerator* enumerator = NULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (folder != NULL);
	{
		GFileEnumerator* _tmp0_ = NULL;
		GFileEnumerator* _tmp1_;
		GFileEnumerator* _tmp2_;
		_tmp1_ = g_file_enumerate_children (folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		_g_object_unref0 (enumerator);
		enumerator = _tmp2_;
		_g_object_unref0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("utils.vala:63: Unable to create enumerator to cleanup flatpak metadata" \
": %s", _tmp4_);
		_g_error_free0 (e);
		_g_object_unref0 (enumerator);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	info = NULL;
	{
		while (TRUE) {
			gboolean _tmp5_ = FALSE;
			GFileInfo* _tmp11_;
			if (!g_cancellable_is_cancelled (cancellable)) {
				GFileInfo* _tmp6_ = NULL;
				GFileEnumerator* _tmp7_;
				GFileInfo* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				_tmp7_ = enumerator;
				_tmp8_ = g_file_enumerator_next_file (_tmp7_, cancellable, &_inner_error0_);
				_tmp6_ = _tmp8_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
				_tmp9_ = _tmp6_;
				_tmp6_ = NULL;
				_g_object_unref0 (info);
				info = _tmp9_;
				_tmp10_ = info;
				_tmp5_ = _tmp10_ != NULL;
				_g_object_unref0 (_tmp6_);
			} else {
				_tmp5_ = FALSE;
			}
			if (!_tmp5_) {
				break;
			}
			_tmp11_ = info;
			if (g_file_info_get_file_type (_tmp11_) != G_FILE_TYPE_DIRECTORY) {
				GFile* child = NULL;
				GFileInfo* _tmp12_;
				const gchar* _tmp13_;
				GFile* _tmp14_;
				GFile* _tmp15_;
				gchar* _tmp16_;
				gchar* _tmp17_;
				GFile* _tmp18_;
				_tmp12_ = info;
				_tmp13_ = g_file_info_get_name (_tmp12_);
				_tmp14_ = g_file_resolve_relative_path (folder, _tmp13_);
				child = _tmp14_;
				_tmp15_ = child;
				_tmp16_ = g_file_get_path (_tmp15_);
				_tmp17_ = _tmp16_;
				g_debug ("utils.vala:72: Deleting %s", _tmp17_);
				_g_free0 (_tmp17_);
				_tmp18_ = child;
				g_file_delete (_tmp18_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (child);
					goto __catch1_g_error;
				}
				_g_object_unref0 (child);
			} else {
				GFile* child = NULL;
				GFileInfo* _tmp19_;
				const gchar* _tmp20_;
				GFile* _tmp21_;
				GFile* _tmp22_;
				GFile* _tmp23_;
				_tmp19_ = info;
				_tmp20_ = g_file_info_get_name (_tmp19_);
				_tmp21_ = g_file_resolve_relative_path (folder, _tmp20_);
				child = _tmp21_;
				_tmp22_ = child;
				catalogue_core_delete_folder_contents (_tmp22_, cancellable);
				_tmp23_ = child;
				g_file_delete (_tmp23_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (child);
					goto __catch1_g_error;
				}
				_g_object_unref0 (child);
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp24_;
		const gchar* _tmp25_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp24_ = e;
		_tmp25_ = _tmp24_->message;
		g_warning ("utils.vala:81: Error while cleaning up flatpak metadat directory: %s", _tmp25_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (info);
		_g_object_unref0 (enumerator);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (info);
	_g_object_unref0 (enumerator);
}

void
catalogue_core_perform_xml_fixups (const gchar* origin_name,
                                   GFile* src_file,
                                   GFile* dest_file)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	xmlDoc* doc = NULL;
	const gchar* _tmp1_;
	xmlDoc* _tmp2_;
	xmlDoc* _tmp3_;
	xmlNode* root = NULL;
	xmlDoc* _tmp5_;
	xmlNode* _tmp6_;
	xmlNode* _tmp7_;
	xmlNode* _tmp10_;
	const gchar* _tmp11_;
	xmlAttr* origin_attr = NULL;
	xmlNode* _tmp14_;
	xmlAttr* _tmp15_;
	xmlAttr* _tmp16_;
	xmlNode* _tmp19_;
	xmlXPathContext* cntx = NULL;
	xmlDoc* _tmp20_;
	xmlXPathContext* _tmp21_;
	xmlXPathObject* res = NULL;
	xmlXPathContext* _tmp22_;
	xmlXPathObject* _tmp23_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	xmlXPathObject* _tmp26_;
	GeeArrayList* sorted_components = NULL;
	GeeArrayList* _tmp38_;
	xmlDoc* _tmp82_;
	xmlDoc* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	xmlXPathObject* _tmp86_;
	xmlDoc* _tmp87_;
	g_return_if_fail (origin_name != NULL);
	g_return_if_fail (src_file != NULL);
	g_return_if_fail (dest_file != NULL);
	_tmp0_ = g_file_get_path (src_file);
	path = _tmp0_;
	_tmp1_ = path;
	_tmp2_ = xmlParseFile (_tmp1_);
	doc = _tmp2_;
	_tmp3_ = doc;
	if (_tmp3_ == NULL) {
		const gchar* _tmp4_;
		_tmp4_ = path;
		g_warning ("utils.vala:89: Appstream XML file %s not found or permissions missing", _tmp4_);
		_g_free0 (path);
		return;
	}
	_tmp5_ = doc;
	_tmp6_ = xmlDocGetRootElement (_tmp5_);
	root = _tmp6_;
	_tmp7_ = root;
	if (_tmp7_ == NULL) {
		xmlDoc* _tmp8_;
		const gchar* _tmp9_;
		_tmp8_ = doc;
		_xmlFreeDoc0 (_tmp8_);
		_tmp9_ = path;
		g_warning ("utils.vala:96: The xml file '%s' is empty", _tmp9_);
		_g_free0 (path);
		return;
	}
	_tmp10_ = root;
	_tmp11_ = _tmp10_->name;
	if (g_strcmp0 (_tmp11_, "components") != 0) {
		xmlDoc* _tmp12_;
		const gchar* _tmp13_;
		_tmp12_ = doc;
		_xmlFreeDoc0 (_tmp12_);
		_tmp13_ = path;
		g_warning ("utils.vala:102: The root node of %s isn't 'components', valid appstrea" \
"m file?", _tmp13_);
		_g_free0 (path);
		return;
	}
	_tmp14_ = root;
	_tmp15_ = xmlHasProp (_tmp14_, (xmlChar*) "origin");
	origin_attr = _tmp15_;
	_tmp16_ = origin_attr;
	if (_tmp16_ == NULL) {
		xmlDoc* _tmp17_;
		const gchar* _tmp18_;
		_tmp17_ = doc;
		_xmlFreeDoc0 (_tmp17_);
		_tmp18_ = path;
		g_warning ("utils.vala:109: The root node of %s doesn't have an origin attribute, " \
"valid appstream file?", _tmp18_);
		_g_free0 (path);
		return;
	}
	_tmp19_ = root;
	xmlSetProp (_tmp19_, (xmlChar*) "origin", (xmlChar*) origin_name);
	_tmp20_ = doc;
	_tmp21_ = xmlXPathNewContext (_tmp20_);
	cntx = _tmp21_;
	_tmp22_ = cntx;
	_tmp23_ = xmlXPathEvalExpression ((xmlChar*) "/components/component/metadata", _tmp22_);
	res = _tmp23_;
	_tmp26_ = res;
	if (_tmp26_ != NULL) {
		xmlXPathObject* _tmp27_;
		_tmp27_ = res;
		_tmp25_ = _tmp27_->type == XPATH_NODESET;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		xmlXPathObject* _tmp28_;
		xmlNodeSet* _tmp29_;
		_tmp28_ = res;
		_tmp29_ = _tmp28_->nodesetval;
		_tmp24_ = _tmp29_ != NULL;
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp30_ = FALSE;
				_tmp30_ = TRUE;
				while (TRUE) {
					xmlXPathObject* _tmp32_;
					xmlNodeSet* _tmp33_;
					xmlNode* node = NULL;
					xmlXPathObject* _tmp34_;
					xmlNodeSet* _tmp35_;
					xmlNode* _tmp36_;
					xmlNode* _tmp37_;
					if (!_tmp30_) {
						gint _tmp31_;
						_tmp31_ = i;
						i = _tmp31_ + 1;
					}
					_tmp30_ = FALSE;
					_tmp32_ = res;
					_tmp33_ = _tmp32_->nodesetval;
					if (!(i < xmlXPathNodeSetGetLength (_tmp33_))) {
						break;
					}
					_tmp34_ = res;
					_tmp35_ = _tmp34_->nodesetval;
					_tmp36_ = xmlXPathNodeSetItem (_tmp35_, i);
					node = _tmp36_;
					_tmp37_ = node;
					xmlNodeSetName (_tmp37_, (xmlChar*) "custom");
				}
			}
		}
	}
	_tmp38_ = gee_array_list_new (G_TYPE_POINTER, NULL, NULL, NULL, NULL, NULL);
	sorted_components = _tmp38_;
	{
		xmlNode* component = NULL;
		xmlNode* _tmp39_;
		xmlNode* _tmp40_;
		_tmp39_ = root;
		_tmp40_ = _tmp39_->children;
		component = _tmp40_;
		{
			gboolean _tmp41_ = FALSE;
			_tmp41_ = TRUE;
			while (TRUE) {
				xmlNode* _tmp44_;
				xmlNode* _tmp45_;
				const gchar* _tmp46_;
				if (!_tmp41_) {
					xmlNode* _tmp42_;
					xmlNode* _tmp43_;
					_tmp42_ = component;
					_tmp43_ = _tmp42_->next;
					component = _tmp43_;
				}
				_tmp41_ = FALSE;
				_tmp44_ = component;
				if (!(_tmp44_ != NULL)) {
					break;
				}
				_tmp45_ = component;
				_tmp46_ = _tmp45_->name;
				if (g_strcmp0 (_tmp46_, "component") != 0) {
					continue;
				}
				{
					xmlNode* iter = NULL;
					xmlNode* _tmp47_;
					xmlNode* _tmp48_;
					_tmp47_ = component;
					_tmp48_ = _tmp47_->children;
					iter = _tmp48_;
					{
						gboolean _tmp49_ = FALSE;
						_tmp49_ = TRUE;
						while (TRUE) {
							xmlNode* _tmp52_;
							xmlNode* _tmp53_;
							const gchar* _tmp54_;
							if (!_tmp49_) {
								xmlNode* _tmp50_;
								xmlNode* _tmp51_;
								_tmp50_ = iter;
								_tmp51_ = _tmp50_->next;
								iter = _tmp51_;
							}
							_tmp49_ = FALSE;
							_tmp52_ = iter;
							if (!(_tmp52_ != NULL)) {
								break;
							}
							_tmp53_ = iter;
							_tmp54_ = _tmp53_->name;
							if (g_strcmp0 (_tmp54_, "bundle") == 0) {
								gchar* bundle_id = NULL;
								xmlNode* _tmp55_;
								gchar* _tmp56_;
								const gchar* _tmp57_;
								const gchar* _tmp58_;
								_tmp55_ = iter;
								_tmp56_ = (gchar*) xmlNodeGetContent (_tmp55_);
								bundle_id = _tmp56_;
								_tmp57_ = bundle_id;
								if (!g_str_has_prefix (_tmp57_, "app/")) {
									_g_free0 (bundle_id);
									break;
								}
								_tmp58_ = bundle_id;
								if (g_str_has_suffix (_tmp58_, "/stable")) {
									GeeArrayList* _tmp59_;
									xmlNode* _tmp60_;
									_tmp59_ = sorted_components;
									_tmp60_ = component;
									gee_abstract_list_insert ((GeeAbstractList*) _tmp59_, 0, _tmp60_);
								} else {
									GeeArrayList* _tmp61_;
									xmlNode* _tmp62_;
									_tmp61_ = sorted_components;
									_tmp62_ = component;
									gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp62_);
								}
								_g_free0 (bundle_id);
								break;
							}
						}
					}
				}
			}
		}
	}
	{
		GeeArrayList* _component_list = NULL;
		GeeArrayList* _tmp63_;
		gint _component_size = 0;
		GeeArrayList* _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		gint _component_index = 0;
		_tmp63_ = sorted_components;
		_component_list = _tmp63_;
		_tmp64_ = _component_list;
		_tmp65_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp64_);
		_tmp66_ = _tmp65_;
		_component_size = _tmp66_;
		_component_index = -1;
		while (TRUE) {
			gint _tmp67_;
			gint _tmp68_;
			xmlNode* component = NULL;
			GeeArrayList* _tmp69_;
			gpointer _tmp70_;
			xmlNode* _tmp71_;
			_component_index = _component_index + 1;
			_tmp67_ = _component_index;
			_tmp68_ = _component_size;
			if (!(_tmp67_ < _tmp68_)) {
				break;
			}
			_tmp69_ = _component_list;
			_tmp70_ = gee_abstract_list_get ((GeeAbstractList*) _tmp69_, _component_index);
			component = _tmp70_;
			_tmp71_ = component;
			xmlUnlinkNode (_tmp71_);
		}
	}
	{
		GeeArrayList* _component_list = NULL;
		GeeArrayList* _tmp72_;
		gint _component_size = 0;
		GeeArrayList* _tmp73_;
		gint _tmp74_;
		gint _tmp75_;
		gint _component_index = 0;
		_tmp72_ = sorted_components;
		_component_list = _tmp72_;
		_tmp73_ = _component_list;
		_tmp74_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp73_);
		_tmp75_ = _tmp74_;
		_component_size = _tmp75_;
		_component_index = -1;
		while (TRUE) {
			gint _tmp76_;
			gint _tmp77_;
			xmlNode* component = NULL;
			GeeArrayList* _tmp78_;
			gpointer _tmp79_;
			xmlNode* _tmp80_;
			xmlNode* _tmp81_;
			_component_index = _component_index + 1;
			_tmp76_ = _component_index;
			_tmp77_ = _component_size;
			if (!(_tmp76_ < _tmp77_)) {
				break;
			}
			_tmp78_ = _component_list;
			_tmp79_ = gee_abstract_list_get ((GeeAbstractList*) _tmp78_, _component_index);
			component = _tmp79_;
			_tmp80_ = root;
			_tmp81_ = component;
			xmlAddChild (_tmp80_, _tmp81_);
		}
	}
	_tmp82_ = doc;
	xmlSetDocCompressMode (_tmp82_, 7);
	_tmp83_ = doc;
	_tmp84_ = g_file_get_path (dest_file);
	_tmp85_ = _tmp84_;
	xmlSaveFile (_tmp85_, _tmp83_);
	_g_free0 (_tmp85_);
	_tmp86_ = res;
	_xmlXPathFreeObject0 (_tmp86_);
	_tmp87_ = doc;
	_xmlFreeDoc0 (_tmp87_);
	_g_object_unref0 (sorted_components);
	_xmlXPathFreeContext0 (cntx);
	_g_free0 (path);
}

